(function ($) {

  /**
   * Drupal javascript behaviors.
   */
  Drupal.behaviors.activeLinksExtras = {
    attach: function attach(context, settings) {
      if (context.tagName == 'SCRIPT') {
        return;
      }

      // Add class "is-active" and "is-active-trail" to links
      $('a[href="' + location.pathname + location.search + '"]', context).addClass('is-active');
      if (drupalSettings.path.currentQuery) {
        $('a[data-drupal-link-system-path="' + drupalSettings.path.currentPath + '"]:not([data-drupal-link-query])', context).addClass('is-active-trail');
      }

      // Add class "is-active" and "is-active-trail" to parent li
      var $liContainingActiveLink = $('a.is-active').closest('li');
      if ($liContainingActiveLink.length) {
        $liContainingActiveLink
          .addClass('is-active')
          .parents('li').addClass('is-active-trail');
      }

    }
  };

})(jQuery);
