jQuery.widget('ui.dialog', jQuery.ui.dialog, {
  /**
   * Override _createOverlay().
   */
  _createOverlay: function() {
    // Show custom overlay
    if (this.options.modal && this.options.customOverlay) {
      Drupal.overlayShow('dialog', true);
    }
    else {
      this._superApply(arguments);
    }
  },

  /**
   * Override _destroyOverlay().
   */
  _destroyOverlay: function() {
    // Hide custom overlay
    if (this.options.modal && this.options.customOverlay) {
      Drupal.overlayHide('dialog', true);
    }
    else {
      this._superApply(arguments);
    }
  },

  /**
   * Add public method for destroy overlay.
   */
  destroyOverlay: function() {
    this._destroyOverlay();
  },

  /**
   * Override _focusTabbable().
   */
  _focusTabbable: function () {
    var $autofocusElement = this.element.find('[autofocus]:first');
    if ($autofocusElement.length && !$autofocusElement.is(':focus')) {
      $autofocusElement.focus();
    }
  }
});
