(function ($) {

  Drupal.behaviors.slick = {
    attach: function (context, settings) {
      if (context.tagName == 'SCRIPT' || !$.fn.slick) {
        return;
      }

      $('.slick', context).once('slick').each(function () {
          var $slick = $(this);
          var presetName = null;

          // Get preset name
          $.each($slick.attr('class').split(' '), function (index, className) {
            var presetMatches = className.match(/^slick-preset-(.+)$/);
            if (presetMatches) {
              presetName = $.camelCase(presetMatches[1]);
              return false;
            }
          });

          Drupal.slick($slick, presetName);
        });
    }
  };

  Drupal.slick = function (target, presetName, options) {
    var $slick = $(target);

    // Error handlers
    if (!presetName) {
      console.error('Slick preset name not found.');
      return false;
    }
    if (!Drupal.slickPresets) {
      console.error('Slick presets not exist.');
      return false;
    }
    if (!Drupal.slickPresets[presetName]) {
      console.error('Slick preset "' + presetName + '" not exist.');
      return false;
    }
    if ($slick.length == 0) {
      return false;
    }
    if ($slick.children().length <= 1) {
      return false;
    }

    if (!$slick.hasClass('slick')) {
      $slick.addClass('slick');
    }

    options = $.extend({}, Drupal.slickPresets[presetName], options);

    $slick.slick(options);

    // Fix vertical slick height - remove last visible slide margin from list height
    /** @see Slick.setDimensions() */
    if (options.vertical) {
      $slick.on('setPosition', function () {
        var $firstSlide = $slick.find('.slick-slide:first');
        var firstSlideHeight = $firstSlide.outerHeight();
        var firstSlideVerticalMargin = $firstSlide.outerHeight(true) - firstSlideHeight;
        $slick.find('.slick-list').height(firstSlideHeight * options.slidesToShow + firstSlideVerticalMargin * (options.slidesToShow - 1));
      });
    }
  }

})(jQuery);
