(function ($) {

  /**
   * DOM ready.
   */
  $(document).ready(function () {
    // Integrate clickToggle plugin with overlay.
    $(this).on('clickToggleOpen clickToggleClose', function (event, settings) {
      if (settings.showOverlay) {
        // Show overlay
        if (event.type == 'clickToggleOpen') {
          Drupal.overlayShow('clicktoggle', settings.disableScroll);
        }
        // Hide overlay
        else {
          Drupal.overlayHide('clicktoggle', settings.disableScroll, settings.overlayHideTimeout);
        }
      }
    });
  });

  /**
   * Drupal javascript behaviors.
   */
  Drupal.behaviors.xbase = {
    attach: function attach(context, settings) {
      if (context.tagName == 'SCRIPT') {
        return;
      }

      // Clean phone in "tel:" links
      $('a[href^="tel:"]').once('phone-link').each(function () {
        var $a = $(this);
        var phone = $a.attr('href').match(/tel:(.+)/)[1];
        var cleanPhone = phone.replace(/[^\d+]/g, '');

        if (phone != cleanPhone) {
          $a.attr('href', 'tel:' + cleanPhone);
        }
      });

      // Colorbox
      if (Drupal.behaviors.initColorbox) {
        var $linksWithColorboxContent = $('a:not(.colorbox):has(img.colorbox-content)', context);
        if ($linksWithColorboxContent.length) {
          $linksWithColorboxContent.addClass('colorbox');
          Drupal.behaviors.initColorbox.attach($linksWithColorboxContent, settings);
        }
      }

    }
  };

})(jQuery);
